using System;
using System.Configuration;

namespace JamesKovacs.Web.HttpModules {
    public sealed class Availability : ApplicationSettingsBase {
        private Availability() {
        }
        
        private static Availability defaultInstance = ((Availability)(Synchronized(new Availability())));

        /// <summary>
        /// Gets the default instance.
        /// </summary>
        /// <value>The instance.</value>
        public static Availability Instance {
            get {
                return defaultInstance;
            }
        }

        /// <summary>
        /// Gets the start time.
        /// </summary>
        /// <value>The start time.</value>
        [ApplicationScopedSetting]
        [DefaultSettingValue("6:00 AM")]
        public DateTime StartTime {
            get {
                return (DateTime)this["StartTime"];
            }
        }

        /// <summary>
        /// Gets the end time.
        /// </summary>
        /// <value>The end time.</value>
        [ApplicationScopedSetting]
        [DefaultSettingValue("6:00 PM")]
        public DateTime EndTime {
            get {
                return (DateTime)this["EndTime"];
            }
        }
    }
}
