using System;
using System.Collections.Generic;
using System.IO;
using System.Security.Principal;
using System.Threading;
using System.Web;
using System.Web.Caching;
using System.Xml.XPath;

namespace JamesKovacs.Web.HttpModules {
    public class SiteAvailabilityHttpModule : IHttpModule {
        #region IHttpModule Members
        public void Dispose() {
            // NOP
        }

        public void Init(HttpApplication context) {
            context.PostAuthorizeRequest += new EventHandler(context_PostAuthorizeRequest);
        }

        void context_PostAuthorizeRequest(object sender, EventArgs e) {
            string ext = Path.GetExtension(HttpContext.Current.Request.Path).ToLowerInvariant();
            if(ext == ".aspx") {
                if(!HttpContext.Current.User.IsInRole("Administrator")) {
                    TimeSpan now = DateTime.Now.TimeOfDay;
                    if(now < Availability.Instance.StartTime.TimeOfDay
                            || now > Availability.Instance.EndTime.TimeOfDay) {
                        HttpContext.Current.RewritePath("~/SiteUnavailable.aspx");
                    }
                }
            }
        }
        #endregion
    }
}
